' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Dim objDSE, strDefaultDN, strDN, objADObject, i
Dim objSecDesc, objDACL, objACE

Set objDSE = GetObject("LDAP://rootDSE")
strDefaultDN = "CN=Users," & objDSE.Get("defaultNamingContext")

strDN = 	InputBox("Enter the distinguished name of an object" & _
	vbCrLf & "(e.g. " & strDefaultDN & ")", , strDefaultDN)

If strDN = "" Then WScript.Quit(0)  'user clicked Cancel

Set objADObject = GetObject("LDAP://" & strDN)

Set objSecDesc = objADObject.Get("ntSecurityDescriptor")
Set objDACL = objSecDesc.DiscretionaryAcl

WScript.Echo "Number of ACEs: " & objDACL.AceCount

i = 0
For Each objACE In objDACL
	i = i + 1
	WScript.Echo ""
	WScript.Echo "ACE " & i
	WScript.Echo "Trustee: " & objACE.Trustee
	WScript.Echo "AccessMask: " & Hex(objACE.AccessMask)
	WScript.Echo "AceFlags: " & Hex(objACE.AceFlags)
	WScript.Echo "AceType: " & Hex(objACE.AceType)
	WScript.Echo "Flags: " & Hex(objACE.Flags)
	WScript.Echo "ObjectType: " & objACE.ObjectType
	WScript.Echo "InheritedObjectType: " & objACE.InheritedObjectType
Next
